//
// DirectAction.java
// Project MixedSite
//
// Created by paul on Mon Dec 10 2001
//

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import java.net.*;

public class DirectAction extends WODirectAction {

    public DirectAction(WORequest aRequest) {
        super(aRequest);
    }

    public WOActionResults defaultAction() {
        NSLog.debug.appendln("defaultAction");
        // return pageWithName("Main");
        return fileAction();
    }

    public WOActionResults woAction() {
        String content = (String)request().formValueForKey("wo");
        if (content == null) content = (String)request().formValueForKey("WOIsmapCoords");
        if (content != null) {
            WOComponent nextPage = pageWithName(content);
            return nextPage;
        }
        return null;
    }

    public WOActionResults fileAction() {
        String content = (String)request().formValueForKey("file");
        if (content == null) content = (String)request().formValueForKey("WOIsmapCoords");
        if (content == null) content = "index.html";

        WOResponse nextPage = new WOResponse();
        content = PLUtilities.getFileString(NSPathUtilities.stringByAppendingPathComponent(docRoot(), content));
        // should filter content for custom tags first
        content = plInclude(content);
        content = plUrl(content);
        nextPage.appendContentString(content);
        return nextPage;
    }

    public WOActionResults urlAction() {
        String content = (String)request().formValueForKey("url");
        if (content == null) content = (String)request().formValueForKey("WOIsmapCoords");
        if (content != null) {
            WOResponse nextPage = new WOResponse();
            content = PLUtilities.getURLString(content);
            // should filter content for custom tags first
            nextPage.appendContentString(content);
            return nextPage;
        }
        return null;
    }

// Utility code

    public static String docRoot() {
        return "/Library/WebServer/Documents";
    }

    public String plInclude(String value) {
        TagParser tp = new TagParser(value);
        Tag myTag = tp.getNextTag("PLINCLUDE");
        while (myTag != null) {
            // NSLog.debug.appendln("Tag: " + myTag.toString());
            tp.replaceTag(myTag, PLUtilities.getFileString(NSPathUtilities.stringByAppendingPathComponent(docRoot(), (String)myTag.attributes().valueForKey("file"))));
            myTag = tp.getNextTag("PLINCLUDE");
        }
        return tp.string();
    }

    public String plUrl(String value) {
        TagParser tp = new TagParser(value);
        Tag myTag = tp.getNextTag("PLURL");
        while (myTag != null) {
            // NSLog.debug.appendln("Tag: " + myTag.toString());
            tp.replaceTag(myTag, PLUtilities.getURLString(URLDecoder.decode((String)myTag.attributes().valueForKey("url"))));
            myTag = tp.getNextTag("PLURL");
        }
        return tp.string();
    }

}
