//
// Tag.java
// Project Content
//
// Created by paul on Sat 24-Jun-2000
//

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import java.util.*;

public class Tag extends Object {

    protected NSMutableDictionary attributes;
    protected String content;
    protected int begin, end;

    public int begin() {
        return begin;
    }
    public void setBegin(int i) {
        begin = i;
    }

    public int end() {
        return end;
    }
    public void setEnd(int i) {
        end = i;
    }

    public NSDictionary attributes() {
        return attributes;
    }
    public void setAttributes(NSDictionary dict) {
        attributes = (NSMutableDictionary)dict;
    }
    public void setAttribute(String value, String key) {
        attributes.setObjectForKey(value, key);
    }
    public void removeAttribute(String key) {
        attributes.removeObjectForKey(key);
    }
    public String attribute(String key) {
        return (String)attributes.objectForKey(key);
    }

    public String content() {
        return content;
    }
    public void setContent(String value) {
        content = value;
    }

    public String tagString() {
        String string = "<";
        string += attribute("tag");
        Enumeration index = attributes().keyEnumerator();
        while (index.hasMoreElements()) {
            String key = (String)index.nextElement();
            if (!key.equalsIgnoreCase("tag")) {
                string += key;
                if (!attribute(key).equals("")) {
                    string += "=";
                    string += attribute(key);
                }
            }
        }
        string += ">";
        if (content != null) {
            string += content();
            string += "</";
            string += attribute("tag");
            string += ">";
        }
        return string;
    }

    public String toString() {
        return "content: " + content +" begin: " + begin + " end: " + end + " attributes: " + attributes;
    }

}
