//
// TagParser.java
// Project Content
//
// Created by paul on Sat 24-Jun-2000
//

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import java.util.*;
import java.net.*;

public class TagParser extends Object {

    protected String string;
    protected int index;

    public TagParser(String value) {
        setString(value);
    }

    public String string() {
        return string;
    }

    public void setString(String value) {
        string = value;
        index = 0;
    }

    public void replaceTag(Tag tag, String newtag) {
        // needs to do more - copy other attributes across from Tag
        setString(string.substring(0, tag.begin()) + newtag + string.substring(tag.end()));
    }

    public Tag getNextTag(String name) {
        Tag tagDict = getNextTag();
        while (tagDict != null) {
            if (tagDict.attribute("tag").equalsIgnoreCase(name))
                return tagDict;
            tagDict = getNextTag();
        }
        return null;
    }

    public Tag getNextTag() {	// warning - this doesn't permit nested tags
        NSMutableDictionary tagDict = new NSMutableDictionary();
        Tag tagValue = new Tag();
        String tag = "";
        String content = "";
        int i, j, m;

        i = string.indexOf('<', index);
        if (i == -1) return null;
        j = string.indexOf('>', i);
        if (j == -1) return null;
        tag = string.substring(i + 1, j);

        StringTokenizer tok = new StringTokenizer(tag);

        while(tok.hasMoreElements()) {
            String token = tok.nextToken();
            if (tagDict.count() == 0) {	// first token; i.e. the tag
                tagDict.setObjectForKey(token, "tag");
            } else {
                int k = token.indexOf('=');
                if (k == -1) {	// not found
                    tagDict.setObjectForKey("", token);
                } else {
                    // not ideal - used to permit spaces in parameters
                    String value = token.substring(k+1).replace('+', ' ');
                    tagDict.setObjectForKey(URLEncoder.encode(value), token.substring(0, k));
                }
            }
        }

        // look for tag closure
	String closetag = "</" + tagDict.objectForKey("tag") + ">";
        // requires same case!
        m = string.indexOf(closetag, j + 1);
        if (m == -1)
            m = j;
        else {
            content = string.substring(j + 1, m);
            m += closetag.length();
        }
        
//        WOApplication.debugString("tagDict: " + tagDict + " closetag: " + closetag + " content: " + content);
//        debugString("begin: " + i + " middle: " + j + " end: " + m + " length: " + string.length());
        
        index = j + 1;
        tagValue.setAttributes(tagDict);
        tagValue.setBegin(i);
        tagValue.setEnd(m);
        tagValue.setContent(content);
        return tagValue;
    }

}
